// LISTING 3 --- HELPTEST.CPP 
// Test of the context-sensitive help system
// (c) 1990 C Gazette -- Use freely if authorship acknowledged

#include <stdio.h>
#include <conio.h>
#include "cshelp.hpp"

char * screen1[] = {
"This screen is the (new) top help level",
"F2 to quit",
"" // terminator
};

char * screen2[] = {
"This screen is the second help level",
"F1 to go up one level, F2 to quit",
"" // terminator
};

char * screen3[] = {
"This screen is created with new and destroyed with delete",
"" // terminator
};

void foreground_process() {
  puts("press F1 for help, ESC to quit this section");
    while(putchar(getch()) != 27)
      ;
}

main() {
  foreground_process();  // uses default_help_screen
  {
  puts("\n adding screen1");
  help_handler s1(screen1);  // default replaced with screen1
  foreground_process();
    {
    puts("\n adding screen2");
    help_handler s2(screen2);  // uses screen2, up to screen1
    foreground_process();
    puts("\n up one help level");
    }
  foreground_process();  // uses screen1
  puts("\n up one help level");
  }
  foreground_process();  // uses default_help_screen
  // Use new & delete for dynamically-created help_handler:
  help_handler * hh = new help_handler(screen3);
  puts("\n created new help_handler");
  foreground_process();
  delete hh;
  puts("\n deleted hh");
  foreground_process();  // uses default_help_screen
}